# README

JavaScript 基础工具库，提供统一一致的API、高性能、模块化的SDK。

对标开源件： lodash

## API Documents

已上线API [参看](./docs/wdk.md) 

## 代码提交要求

- 不能有额外的非国产化软件的依赖
- 每个 API 函数至少包含2个测试用例，一个为功能测试用例，一个为性能测试用例
- 文档、code、commit message 都将视为**代码**，检视时一并审视。
- Commit message 必须符合 [Conventional Commits](https://www.conventionalcommits.org/en/v1.0.0/) 规范要求。会有工具检查，相关工具会在 `npm install` 时安装好

## 如何贡献代码

由于我们没有其他的系统来管理需求和bug，所以本项目采用 codehub 上的 issue 系统来管理 bug 和需求。
所有的需求和bug，请在项目中[Issue列表](https://open.codehub.huawei.com/OpenBaize/JS/wdk/issues)新建issue。
对于有需要进行讨论的 issue，请在 Welink 群中发出issue 链接和标题，吸引在issue下面发帖留言进行讨论。
> Q: 为什么不在 Welink 群中讨论
> A: Welink 人多，并且不是每个人都有兴趣；而且讨论的闪光点不利于记录成册，方便后面开发或者拟定新的课题或者issue。

根据代码仓库的提交要求，每一个 MR 都应该有一个 issue，代码仓库中要求每一个 MR 必须关联一个 issue 号。

更多内容请在 Welink 群中咨询讨论。 Welink 群ID：<font color="blue">599524300</font>


## 内源项目相关信息

https://baize.rnd.huawei.com/store/cbb/codelib/131469   含流水线信息
