/**
 * 创建一个返回 value 的函数。
 * @param value  (*): 要新函数返回的值。
 * @returns (Function): 返回新的常量函数。
 * @example
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
export default function constant(value?: any): Function;
