/**
 * 该函数接受多个函数作为入参（funcArr），而后返回一个新函数fn
 * fn在执行时，依次调用之前的多个函数，前一个函数的输出将作为后一个函数的输入
 * 最后一个函数的输出作为fn函数的返回结果
 * @param funcArr，多个函数入参组成的数组
 * @return 返回一个新函数fn，其被调用时会依次执行funcArr中函数，并返回最终得到的结果
 */
declare function flow(...funcArr: Function[]): (...args: any[]) => any;
export default flow;
