"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 根据二维数组entries生成一个新对象并返回。
 * @param entries，二维数组，对于其中每个元素entry，将entry[0]作为属性，entry[1]作为值，以此生成对象
 * @return 返回一个对象，其属性和值由entries中每个entry生成
 */
function fromPairs(entries) {
    var result = {};
    if (!Array.isArray(entries)) {
        return result;
    }
    entries.forEach(function (entry) {
        if (entry === undefined || entry === null) {
            return;
        }
        result[entry[0]] = entry[1];
    });
    return result;
}
exports.default = fromPairs;
