"use strict";
/**
 * Replaces matches for `pattern` in `string` with `replacement`.
 *
 * **Note:** This method is based on
 * [`String#replace`](https://mdn.io/String/replace).
 *
 * @since 1.0.0
 * @category String
 * @param {string} [str=''] The string to modify.
 * @param {RegExp|string} pattern The pattern to replace.
 * @param {Function|string} replacement The match replacement.
 * @returns {string} Returns the modified string.
 * @see truncate, trim
 * @example
 *
 * replace('Hi Fred', 'Fred', 'Barney')
 * // => 'Hi Barney'
 */
Object.defineProperty(exports, "__esModule", { value: true });
function replace(str, pattern, replacement) {
    var newStr = "".concat(str);
    if (pattern == null || replacement == null) {
        return newStr;
    }
    return newStr.replace(pattern, replacement);
}
exports.default = replace;
