/**
 * 根据属性路径取得obj中的值，如果过程中遇见函数则会先计算函数返回结果，并转而在该结果上继续根据剩余路径去取值
 * @param obj，属性路径所属的对象
 * @param rawPath，属性路径
 * @param defaultValue，默认返回值，如果在取值过程中遇见undefined则直接返回defaultValue。可以是一个函数，会转而将其执行结果作为返回值
 * @return，返回根据属性路径在obj上遍历后取得的值，如遇undefined则返回defaultValue或其执行结果
 */
declare function result(obj: Object, rawPath?: string[] | string, defaultValue?: any): any;
export default result;
