/**
 * 从给定数组中取前 n 个元素返回新数组
 *
 * @param {ArrayLike<any> | undefined} from 给定数组.
 * @param {number} [n=1] 要取的元素数量，默认为 1
 * @returns 最多包含 n 个元素的新数组
 * @example
 *
 * take([1, 2, 3])
 * // => [1]
 *
 * take([1, 2, 3], 2)
 * // => [1, 2]
 *
 * take([1, 2, 3], 5)
 * // => [1, 2, 3]
 *
 * take([1, 2, 3], 0)
 * // => []
 */
export default function take(from?: ArrayLike<any> | null, n?: number): any[];
