/**
 * 调用 iteratee n 次，每次调用返回的结果存入到数组中。 iteratee 调用入1个参数： (index)。
 *
 * @since 1.0.0
 * @param n (number): 调用 iteratee 的次数。
 * @param iteratee (Function): 每次迭代调用的函数。接受一个参数 index
 * @returns (Array): 返回调用结果的数组。
 * @example
 * _.times(3, String);
 * // => ['0', '1', '2']
 *
 *  _.times(4, _.constant(0));
 * // => [0, 0, 0, 0]
 */
export default function times(n?: number, iteratee?: Function): any[];
