/**
 * 这个方法类似_.union， 除了它接受一个 comparator 调用比较arrays数组的每一个元素。
 * comparator 调用时会传入2个参数： (arrVal, othVal)，返回 true 或者 false，标识相等或者不等。
 * @param arrays (...Array) 要检查的数组
 * @param comparator (Function) 比较函数，调用每一个元素
 * ```
 * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
 * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
 *
 * _.unionWith(objects, others, _.isEqual);
 * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
 * ```
 */
export default function unionWith(...arrays: any[]): any[];
