/**
 * 创建一个给定数组中唯一值（即未重复出现）组成的新数组。新数组中元素的顺序取决于他们在原数组的出现顺序。
 * @param rawArraysAndComparator，
 * （多个）原数组和comparator
 * comparator用于比较两个元素是否等同，等同认为则重复出现
 *
 * @return 给定数组中唯一值组成的新数组
 * @example
 * baseXor([1.1,2.2,2.3] ,[1.4,3.6] ,(e1,e2)=>Math.floor(e1)===Math.floor(e2)) = [2.2, 3.6];
 * 解释执行逻辑：先对每个数组内去重，2.2和2.3经过comparator后认为等同，得到 [1.1,2.2]和[1.4,3.6]，拼接后再去重，得到最后结果[2.2,3.6]
 */
declare function xorWith(...rawArraysAndComparator: any[]): any[];
export default xorWith;
