import { IncrementalExecTask, Project, TaskDetails } from '@ohos/hvigor';
import { PathInfo as CrossPlatformPathInfo } from '../../common/util/path-info.js';
/**
 * 基于DefaultTask定义工程级跨平台任务抽象基类
 *
 * @since 2022/11/28
 */
export declare abstract class BaseOhosProjectTask extends IncrementalExecTask {
    readonly crossPlatformPathInfo: CrossPlatformPathInfo;
    readonly projctRootDir: string;
    readonly isApplication: boolean;
    protected constructor(project: Project, taskDetails: TaskDetails);
    registryAction: () => Function;
    beforeTask(): void;
    initTaskDepends(): void;
    preVerificAtion(): boolean;
    doAndroidAction(): Promise<void>;
    doIosAction(): Promise<void>;
    doTaskAction(): Promise<void>;
}
